


#include <iostream>
#include <ell/LatticeDescriptor.hh>
#include <ell/LatticeDescriptorSQR.hh>
#include <ell/LatticeDescriptorCUB.hh>
#include <ell/LatticeDescriptorFCC.hh>


void test_classLatticeDescriptor(const ell::LatticeDescriptor& ld,
		const std::string& moveStr ) {

	using namespace ell;

		// getName()
	std::cout	<<"->getName()  = " << ld.getName()
				<<std::endl;

	std::cout	<<"-> moveStr = " <<moveStr
				<<"\n-> moveStr.size = "  <<moveStr.size() 
				<<std::endl;
								
		// getSequence()
	std::cout	<<"->getSequence(moveStr).size()  = " 
				<< ld.getSequence(moveStr).size()
				<<std::endl;

		// getString(getSequence(X))
	std::cout	<<"->getString(ld.getSequence(moveStr)) == moveStr = "
				<< (ld.getString(ld.getSequence(moveStr)) == moveStr?
					"true":"false")
				<<std::endl;

		// getBase()
	std::cout	<<"->getBase().size() = " <<ld.getBase().size()
				<<std::endl;

		// getNeighborhood()
	std::cout	<<"->getNeighborhood().size()  = " 
				<< ld.getNeighborhood().size()
				<<std::endl;
		// getAutomorphisms()
	std::cout	<<"->getAutomorphisms().size()  = " 
				<< ld.getAutomorphisms().size()
				<<std::endl;
	
}


int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST =================\n"
				<<" test class : LatticeDescriptor\n"
				<<"==========================================" <<std::endl;
				
		// erzeugen	

	using namespace ell;

		//cubic
	std::cout <<"\n=> creating ell::LatticeDescriptorSQR()" <<std::endl;
		test_classLatticeDescriptor(LatticeDescriptorSQR(), "FLBR");

		// square
	std::cout <<"\n=> creating ell::LatticeDescriptorCUB()" <<std::endl;
		test_classLatticeDescriptor(LatticeDescriptorCUB(), "FLUBRD");

		// fcc
	std::cout <<"\n=> creating ell::LatticeDescriptorFCC()" <<std::endl;
		test_classLatticeDescriptor(LatticeDescriptorFCC(), 
			"FLFRFUFDBLBRBUBDLULDRDRD");

		// == and !=
	std::cout	<<"\n-> (LatticeDescriptorCUB() == LatticeDescriptorCUB())  = "
				<<(LatticeDescriptorCUB() == LatticeDescriptorCUB()?
					"true":"false")
				<<std::endl;
	std::cout	<<"-> (LatticeDescriptorCUB() != LatticeDescriptorSQR())  = "
				<<(LatticeDescriptorCUB() != LatticeDescriptorSQR()?
					"true":"false")
				<<std::endl;
		
	std::cout	<<"============= END OF TEST ================\n" <<std::endl;
	
	return 0;
}
